#include "claserdriver_igps.h"
#include "callsystem.h"
#include "cmserialport.h"
CLaserDriver_IGPS::CLaserDriver_IGPS(const QString& name,int32_t id)
    :CLaserDriver_Base(name,id)
{
}

CLaserDriver_IGPS::~CLaserDriver_IGPS()
{
}

int32_t CLaserDriver_IGPS::init_driver()
{
    m_pSerialPort->open();
    SendCommand(0x61, 1, true);
    WORD wrtn=0;
    QTime time;
    time.start();
    int iWarmTime=m_Variants.get_VData(Var_LaserDriver_WarmTime_ID)->toInt();
    while((3!=(wrtn=SendCommand(0x62, 0, false))))
    {
        if(time.elapsed()>iWarmTime*1000)
        {
            MQT_THROW_STR(QObject::trUtf8("Laser Warm Time out"));
        }
        switch(wrtn)
        {
        case 0: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("System Power on,Laser not Open") );break;
        case 1: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Wait Laser Open") );break;
        case 2: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Opening,Load current") );break;
        case 3: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Open Finished") );break;
        case 4: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Closing") );break;
        case 5: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Err") );break;
        }

    }
    SendCommand(0x3E, 0, true);
    SetPowerRate(LASER,100);
    SetFreq(LASER,500);
    return RTN_SUCCESS1;
}

int32_t CLaserDriver_IGPS::exit_driver()
{
    if(m_bCloseLaser)
    {
        QTime time;
        time.start();
        int iWarmTime=m_Variants.get_VData(Var_LaserDriver_WarmTime_ID)->toInt();
        SendCommand(0x61, 0, true);
        WORD wrtn=0;
        while(2!=(wrtn=SendCommand(0x62, 0, false)))
        {
            if(time.elapsed()>iWarmTime*1000)
            {
                MQT_THROW_STR(QObject::trUtf8("Laser Close Time out"));
            }
            switch(wrtn)
            {
            case 0: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("System Power on,Laser not Open") );break;
            case 1: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Wait Laser Open") );break;
            case 2: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Opening,Load current") );break;
            case 3: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Open Finished") );break;
            case 4: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Closing") );break;
            case 5: m_gSystem.m_SysMsg.SetMsg(QObject::trUtf8("Laser Err") );break;
            }

        }
    }
    m_pSerialPort->close();
    return RTN_SUCCESS1;
}


static unsigned short  CRC16(byte* pDataIn, int iLenIn)
{
    byte buf;
    unsigned short crc16 = 0xFFFF;
    static const unsigned short crc16Table[] =
    {
        0x0000, 0xC0C1, 0xC181, 0x0140, 0xC301, 0x03C0, 0x0280, 0xC241,
            0xC601, 0x06C0, 0x0780, 0xC741, 0x0500, 0xC5C1, 0xC481, 0x0440,
            0xCC01, 0x0CC0, 0x0D80, 0xCD41, 0x0F00, 0xCFC1, 0xCE81, 0x0E40,
            0x0A00, 0xCAC1, 0xCB81, 0x0B40, 0xC901, 0x09C0, 0x0880, 0xC841,
            0xD801, 0x18C0, 0x1980, 0xD941, 0x1B00, 0xDBC1, 0xDA81, 0x1A40,
            0x1E00, 0xDEC1, 0xDF81, 0x1F40, 0xDD01, 0x1DC0, 0x1C80, 0xDC41,
            0x1400, 0xD4C1, 0xD581, 0x1540, 0xD701, 0x17C0, 0x1680, 0xD641,
            0xD201, 0x12C0, 0x1380, 0xD341, 0x1100, 0xD1C1, 0xD081, 0x1040,
            0xF001, 0x30C0, 0x3180, 0xF141, 0x3300, 0xF3C1, 0xF281, 0x3240,
            0x3600, 0xF6C1, 0xF781, 0x3740, 0xF501, 0x35C0, 0x3480, 0xF441,
            0x3C00, 0xFCC1, 0xFD81, 0x3D40, 0xFF01, 0x3FC0, 0x3E80, 0xFE41,
            0xFA01, 0x3AC0, 0x3B80, 0xFB41, 0x3900, 0xF9C1, 0xF881, 0x3840,
            0x2800, 0xE8C1, 0xE981, 0x2940, 0xEB01, 0x2BC0, 0x2A80, 0xEA41,
            0xEE01, 0x2EC0, 0x2F80, 0xEF41, 0x2D00, 0xEDC1, 0xEC81, 0x2C40,
            0xE401, 0x24C0, 0x2580, 0xE541, 0x2700, 0xE7C1, 0xE681, 0x2640,
            0x2200, 0xE2C1, 0xE381, 0x2340, 0xE101, 0x21C0, 0x2080, 0xE041,
            0xA001, 0x60C0, 0x6180, 0xA141, 0x6300, 0xA3C1, 0xA281, 0x6240,
            0x6600, 0xA6C1, 0xA781, 0x6740, 0xA501, 0x65C0, 0x6480, 0xA441,
            0x6C00, 0xACC1, 0xAD81, 0x6D40, 0xAF01, 0x6FC0, 0x6E80, 0xAE41,
            0xAA01, 0x6AC0, 0x6B80, 0xAB41, 0x6900, 0xA9C1, 0xA881, 0x6840,
            0x7800, 0xB8C1, 0xB981, 0x7940, 0xBB01, 0x7BC0, 0x7A80, 0xBA41,
            0xBE01, 0x7EC0, 0x7F80, 0xBF41, 0x7D00, 0xBDC1, 0xBC81, 0x7C40,
            0xB401, 0x74C0, 0x7580, 0xB541, 0x7700, 0xB7C1, 0xB681, 0x7640,
            0x7200, 0xB2C1, 0xB381, 0x7340, 0xB101, 0x71C0, 0x7080, 0xB041,
            0x5000, 0x90C1, 0x9181, 0x5140, 0x9301, 0x53C0, 0x5280, 0x9241,
            0x9601, 0x56C0, 0x5780, 0x9741, 0x5500, 0x95C1, 0x9481, 0x5440,
            0x9C01, 0x5CC0, 0x5D80, 0x9D41, 0x5F00, 0x9FC1, 0x9E81, 0x5E40,
            0x5A00, 0x9AC1, 0x9B81, 0x5B40, 0x9901, 0x59C0, 0x5880, 0x9841,
            0x8801, 0x48C0, 0x4980, 0x8941, 0x4B00, 0x8BC1, 0x8A81, 0x4A40,
            0x4E00, 0x8EC1, 0x8F81, 0x4F40, 0x8D01, 0x4DC0, 0x4C80, 0x8C41,
            0x4400, 0x84C1, 0x8581, 0x4540, 0x8701, 0x47C0, 0x4680, 0x8641,
            0x8201, 0x42C0, 0x4380, 0x8341, 0x4100, 0x81C1, 0x8081, 0x4040
    };

    for ( auto i = 0; i < iLenIn; ++i )
    {
        buf = pDataIn[i]^crc16;
        crc16 >>= 8;
        crc16 ^= crc16Table[ buf ];
    }
    return (crc16);
}

WORD CLaserDriver_IGPS::SendCommand(WORD wCommand, WORD wdata, BOOL bWrite)
{
    QMutexLocker locker(&m_CardMutex);
    BYTE pCommandData[9]={0};
    int iSizeCommand=0;
    if (!bWrite)
    {
        iSizeCommand=8;
        pCommandData[0]=0x02;
        pCommandData[1]=0x03;
        pCommandData[2]=wCommand>>8;//0x00;
        pCommandData[3]=wCommand;
        pCommandData[4]=00;
        pCommandData[5]=01;
        unsigned short crc=CRC16(pCommandData,6);
        pCommandData[6]=	crc;
        pCommandData[7]=	crc>>8;

    }
    else
    {
        iSizeCommand=8;
        pCommandData[0]=0x02;
        pCommandData[1]=0x06;
        pCommandData[2]=wCommand>>8;//0x00;
        pCommandData[3]=wCommand;
        pCommandData[4]=wdata>>8;
        pCommandData[5]=wdata;
        unsigned short crc=CRC16(pCommandData,6);
        pCommandData[6]=crc;
        pCommandData[7]=crc>>8;
    }



    m_pSerialPort->send((const char*)pCommandData,iSizeCommand);
    int32_t irtn=m_pSerialPort->wait();
    char   chRCommandData[9]={0};
    m_pSerialPort->receive(chRCommandData,irtn);

    WORD rtnword=chRCommandData[3]<<8|chRCommandData[4];
    if (bWrite)
    {
        if(irtn!=8)
        {
            MQT_THROW_STR(QObject::trUtf8("Laser ComPort Command:%1,data:%2, "
                                          "Response Count:%3 Incorrect").arg(wCommand)
                          .arg(wdata).arg(irtn));
        }

    }
    else
    {
        if(irtn!=7)
        {

            MQT_THROW_STR(QObject::trUtf8("Laser ComPort Command:%1,data:%2, "
                                          "Response Count:%3 Incorrect").arg(wCommand)
                          .arg(wdata).arg(irtn));
        }
    }
    return rtnword;
}

int CLaserDriver_IGPS::SetFreq(int32_t laserid, float64_t dFreq)
{
    CLaser* pLaser=(CLaser*)FindChannel(laserid);
    Q_ASSERT(pLaser);
    DWORD iFreq=dFreq*1000;
    SendCommand(0x45, iFreq, true);
    SendCommand(0x46, iFreq>>16, true);
    pLaser->m_Variants.set_VData(Var_Laser_Freq_ID,double(iFreq));
    return RTN_SUCCESS1;
}

int CLaserDriver_IGPS::GetFreq(int32_t laserid)
{
    CLaser* pLaser=(CLaser*)FindChannel(laserid);
    Q_ASSERT(pLaser);
    double dFreqReturn;

    DWORD dwFreq=SendCommand(0x45, 0, false);
    DWORD dwFreq1=SendCommand(0x46, 0, false);
    dFreqReturn=(dwFreq1<<16)+dwFreq;
    dFreqReturn/=1000;
    pLaser->m_Variants.set_VData(Var_Laser_Freq_ID,double(dFreqReturn));
    return RTN_SUCCESS1;
}

int CLaserDriver_IGPS::OpenLaserGate(int32_t laserid, bool_t bOpen)
{
    CMotorDriver* pDriver=GET_CARD(MOTOR_DRIVER,CMotorDriver);
    Q_ASSERT(pDriver);
#ifdef __NOT_USE_DWIDE_LASER__
#else

    if (bOpen)
    {
        if(m_gEnbaleLaserOpen)
        {
            CLaser* pLaser=(CLaser*)FindChannel(LASER);
            Q_ASSERT(pLaser);
            GetLaserTime(LASER);
            int iLaserTime=pLaser->m_Variants.get_VData(Var_Laser_LaserTime_ID)->toInt();
            int iLaserTimeLimit=pLaser->m_Variants.get_VData(Var_Laser_LaserTime_Limit_ID)->toInt();

            if(iLaserTime>iLaserTimeLimit)
            {
                MQT_THROW_STR(QObject::trUtf8("Laser use time :%d hours "
                                              "bigger then limit time :%d")
                              .arg(iLaserTime).arg(iLaserTimeLimit));
            }
            pDriver->setio(IO_OUTPUT,OUT_LENS_Blow_Inner,true);
            pDriver->set_cylinder(OUT_Shutter_All_Open,IN_LASER_Shutter_All_Down);
            if (laserid==LASERPATH_D_WIDE)
            {
                pDriver->set_cylinder(OUT_Shutter_Narrow_Open,IN_LASER_Shutter_Narrow_Down);
                pDriver->set_cylinder(OUT_Shutter_Wide_Open,IN_LASER_Shutter_Narrow_Up,FALSE);
            }
            else if (laserid==LASERPATH_D_NARROW)
            {
                pDriver->set_cylinder(OUT_Shutter_Wide_Open,IN_LASER_Shutter_Wide_Down);
                pDriver->set_cylinder(OUT_Shutter_Narrow_Open,IN_LASER_Shutter_Narrow_Up,FALSE);
            }
            else
            {
                Q_ASSERT(0);
            }

        }
    }
    else
    {
        pDriver->set_cylinder(OUT_Shutter_All_Open,IN_LASER_Shutter_All_Up,FALSE);
        pDriver->setio(IO_OUTPUT,OUT_LENS_Blow_Inner,false);
    }
#endif
    return RTN_SUCCESS1;
}

int CLaserDriver_IGPS::SetPowerRate(int32_t laserid, float64_t dPower)
{
    CLaser* pLaser=(CLaser*)FindChannel(laserid);
    Q_ASSERT(pLaser);

    SendCommand(0x41, dPower*500.0/100.0, true);
    pLaser->m_Variants.set_VData(Var_Laser_Power_ID,double(dPower));
    return RTN_SUCCESS1;
}

int CLaserDriver_IGPS::GetPowerRate(int32_t laserid)
{
    CLaser* pLaser=(CLaser*)FindChannel(laserid);
    Q_ASSERT(pLaser);
    double dPower=SendCommand(0x41, 0, false);
    dPower/=500;dPower*=100;
    pLaser->m_Variants.set_VData(Var_Laser_Power_ID,double(dPower));
    return RTN_SUCCESS1;
}

int CLaserDriver_IGPS::SetGateSource(int32_t laserid, bool_t bInt)
{
    CLaser* pLaser=(CLaser*)FindChannel(laserid);
    Q_ASSERT(pLaser);
    CMotorDriver_ACS* pMotorDriver=GET_CARD(MOTOR_DRIVER,CMotorDriver_ACS);
    char strReturn[RESPONSELENGTH]={0},strComm[COMM_LEN]={0};
    sprintf(strComm,"Laser_On=%d",bInt?1:0);
    pMotorDriver->SendCommand(strComm,strReturn);
    pLaser->m_Variants.set_VData(Var_Laser_IntGate_ID,bInt?true:false);
    return RTN_SUCCESS1;
}

int CLaserDriver_IGPS::GetSerial(int32_t laserid)
{
    CLaser* pLaser=(CLaser*)FindChannel(laserid);
    Q_ASSERT(pLaser);
    char* strReturn="IGPS";
    pLaser->m_Variants.set_VData(Var_Base_SerialID_ID,QString(strReturn));
    return RTN_SUCCESS1;
}

